<?php

function civicrm_certify_get_civigroups() {
	if (!civicrm_initialize()) {
		return;
	}
	
	$params = array( 
	  'version' => 3,
		'is_active' => 1,
	);

  $result = civicrm_api( 'group','get',$params );

  return $result;
}

function civicrm_certify_get_particpant_status() {
	if (!civicrm_initialize()) {
		return;
	}
	
	$params = array( 
	  'version' => 3,
		'is_active' => 1,
	);

  $result = civicrm_api( 'ParticipantStatusType','get',$params );

  return $result;
}




function _civicrm_certify_civicrm_get_contact($contact_id) {
	if (!civicrm_initialize()) {
		return;
	}
	
	$params = array( 
	  'version' => 3,
		'contact_id' => $contact_id,
	);	
	$result = civicrm_api( 'contact','getsingle',$params );
	return $result;
}

function _civicrm_certify_civicrm_group_contact($group_id, $contact_id) {
	if (!civicrm_initialize()) {
		return;
	}
	
	$params = array( 
	  'contact_id' => $contact_id,
	  'group_id' => $group_id,
	  'version' => 3,
	);

	  $result = civicrm_api( 'group_contact','create',$params );

	  return $result;
}

function _civicrm_certify_civicrm_get_event($event_id) {
	if (!civicrm_initialize()) {
		return;
	}
	
	$params = array( 
	  'version' => 3,
		'event_id' => $event_id,
	);
	
	$result = civicrm_api( 'event','getsingle',$params );
	return $result;
}

function _civicrm_certify_create_custom_field_group($field_group_name) {
	if (!civicrm_initialize()) {
		return;
	}
	$params = array( 
	  'title' => $field_group_name,
	  'name' => $field_group_name,
	  'extends' => array( 
	      '0' => 'Event',
	    ),
	  'style' => 'Inline',
	  'is_active' => 1,
	  'version' => 3,
	);

	  $result = civicrm_api( 'custom_group','create',$params );

	  return $result;
}

function _civicrm_certify_create_civicrm_custom_field($field_name, $group_id, $option_id) {

	if (!civicrm_initialize()) {
		return;
	}
  $params = array(
    'name' => $field_name,
    'label' => 'Certifications',
		'custom_group_id' => $group_id, //field group
		"option_group_id" => $option_id, //options
    'html_type' => 'Multi-Select',
    'data_type' => 'String',
    'weight' => 1,
		'text_length' => '255',
    'is_required' => 0,
    'is_searchable' => 0,
    'is_active' => 1,
    'version' => 3,
  );

	$result = civicrm_api('custom_field', 'create', $params);
	return $result;

}

function _civicrm_certify_create_civicrm_options(){

	if (!civicrm_initialize()) {
		return;
	}

	$params = array( 
		'version' => 3,
		'sequential' => 1,
		'name' => 'civicrm_certify.options',
		'is_reserved' => 1,
		'is_active' => 1,
	);

  $result = civicrm_api( 'option_group','create',$params );

  return $result;
}

function _civicrm_certify_civicrm_delete_custom_field($field_id) {
	if (!civicrm_initialize()) {
		return;
	}
	$params = array(
		'version' => 3,
		'id' => $field_id,
	);
	$result = civicrm_api( 'custom_field','delete',$params );
	return $result;
}

function _civicrm_certify_civicrm_delete_field_group($group_id) {
	if (!civicrm_initialize()) {
		return;
	}
	$params = array(
		'version' => 3,
		'id' => $group_id,
	);
	$result = civicrm_api( 'custom_group','delete',$params);
	return $result;
}